/*
 * Compute.h
 *
 *  Created on: Aug 11, 2011
 *      Author: janez
 */

#ifndef COMPUTE_H_
#define COMPUTE_H_

#include <vector>

#include "peg_tc.h"
#include "ParticleList.h"
#include "SpatialRegion.h"
#include "Tree.h"

class ParticleList;
class Tree;
class SpatialRegion;

class Compute {
	ParticleList* particlelist;
	Tree* tree;
	SpatialRegion* region;

public:
	static const int COMPUTE_METHOD_DEFAULT = 1;
	static const int COMPUTE_METHOD_GREEN = 2;
	static const int COMPUTE_METHOD_GREEN2 = 3;
	Compute();
	virtual ~Compute();
	virtual void forces( ParticleList& in_pl, Tree& in_tree, SpatialRegion& region ) = 0;
	Vector3 force( ParticleList& in_pl, SpatialRegion& in_region, Particle pt );
	virtual std::vector<double> potential( ParticleList& in_pl, Tree& in_tree, SpatialRegion& in_region ) = 0;
};

#endif /* COMPUTE_H_ */
