/*
 * Compute.h
 *
 *  Created on: Aug 11, 2011
 *      Author: janez
 */

#ifndef COMPUTE_GREEN_H_
#define COMPUTE_GREEN_H_

#include <vector>

#include "peg_tc.h"
#include "Compute.h"
#include "Particle.h"
#include "ParticleList.h"
#include "SpatialRegion.h"
#include "Tree.h"
#include "TreeNode.h"


class Compute_green : public Compute {
	ParticleList* particlelist;
	Tree* tree;
	SpatialRegion* region;
	double A, B;

	void calculate_constants_A_B();

	Vector3 forceOnParticle( Particle *pt );
	double potential_p( double x );
//	double compute_Ec_tc( ParticleList* pl, struct tc_node *node, long int pt_index ) ;
	double compute_Ec_tc( ParticleList* pl, TreeNode *node, Vector3 *pt ) ;
	double compute_Phic_tc( ParticleList* pl, TreeNode *node, double x ) ;
//	double compute_Ec_directSum( ParticleList *pl, struct tc_node *node, long int pt_index);
	double compute_Ec_directSum( ParticleList *pl, TreeNode *node, Vector3 *pt_pos );
	double compute_Phic_directSum( ParticleList *pl, TreeNode *node, double x);

	// Homogeneous part of potential
	inline double potential_h( double x ) {
		return (this->A*x + this->B);
	};

	// Compute E field from given charge and distance.
	inline double compute_Ec_single(double q, double l) {
		return (((l<0) ? -1 : 1) * (q));
	};

	// Compute potential from given charge and given distance.
	inline double compute_Phic_single(double q, double l) {
		return (fabs(l) * q);
	};

public:
	Compute_green();
	virtual ~Compute_green();
	void forces( ParticleList& in_pl, Tree& in_tree, SpatialRegion& region );
	Vector3 force( ParticleList& in_pl, SpatialRegion& in_region, Particle pt );
	std::vector<double> potential( ParticleList& in_pl, Tree& in_tree, SpatialRegion& in_region );
};

#endif /* COMPUTE_GREEN_H_ */
