/*
 * ParticleList.h
 *
 *  Created on: Aug 10, 2011
 *      Author: janez
 */

#ifndef PARTICLELIST_H_
#define PARTICLELIST_H_

#include "peg_tc.h"

#include "Particle.h"
#include <vector>

class ParticleList {
	std::vector<Particle> particles;
//	long int numParticles, maxParticles;

public:
	ParticleList();
	virtual ~ParticleList();
	inline void init() { particles.clear(); };
	void dump(int level);
	bool insertParticle(Particle *p);
	void deleteParticles(std::vector<unsigned int> list);

	inline long memory_footprint() { return particles.size()*sizeof(particles) + sizeof(this); };

	inline long int capacity() { return particles.capacity(); };
	inline long int size() { return particles.size(); };
	inline bool full() { return (particles.size() == particles.capacity()); };

	inline void addParticle( Particle* p ) { particles.push_back( *p ); };
	ParticleList& operator += (ParticleList pl);
	ParticleList& operator += (Particle pl);
	inline Particle *getParticle( unsigned int pos ) { return &particles[pos]; } ;
	Particle operator [] (const unsigned long int pos);

	inline long int max_size() { return particles.max_size(); };


};

#endif /* PARTICLELIST_H_ */
