/*
 * Progress.h
 *
 *  Created on: Aug 15, 2011
 *      Author: janez
 */

#ifndef PROGRESS_H_
#define PROGRESS_H_

#include "peg_tc.h"

#include <string>
#include <sys/time.h>
#include <map>
#include <vector>

// when changing structure, also change method "init"!
struct indicator {
	double mark;
	std::string format;
	long int stepNextPrint;
	long int stepDelta;
	bool dump;
	std::string toFile;
};

class Progress {
	long int maxStep;
	struct timeval tstamp;
	std::string outFile;
	std::string timeString(struct timeval* t);
	double time_diff_d( struct timeval t2, struct timeval t1 );
	struct timeval time_diff( struct timeval t2, struct timeval t1 );
	std::vector<struct indicator> indicators;
	void displayMessage(std::string mess);
	void init( unsigned int pos );

public:
	Progress();
	virtual ~Progress();
	long long memory_footprint() { return sizeof(this) + indicators.size()*sizeof(struct indicator); };

	inline void setMaxStep(long int inMaxStep) { maxStep = inMaxStep; } ;
	inline void setOutFile( std::string inOutFile ) { outFile = inOutFile; } ;
	void addIndicator( double inMark, std::string inFormat );
	void addIndicator( double inMark, std::string toFile, std::string whatToDisplay );

	inline void mark() { gettimeofday(&tstamp, NULL); };
	void display(long int step);
	void displayIndicator(long int step);


};

#endif /* PROGRESS_H_ */
