/*
 * Species.h
 *
 *  Created on: Aug 7, 2011
 *      Author: janez
 */

#ifndef SPECIES_H_
#define SPECIES_H_

#include "peg_tc.h"

#include <string>

class Species {
	std::string name;
	double q, m;
	double p2c;

public:
	Species();
	virtual ~Species();
	void dump(int level, int index);
	std::string dump2string();
	inline long long memory_footprint() { return sizeof(this); };


	inline void init() { q = m = 0; p2c = 1; name = ""; } ;
//	inline void set( std::string inName, double in_q, double in_m ) ;
	// get and set values for name, charge and mass
	inline double get_q() { return q; };
	inline double get_m() { return m; };
	inline std::string get_name() { return name; };
	inline void set_q(double in_q) { q = in_q;};
	inline void set_m(double in_m) { m = in_m;};
	inline void set_name(std::string in_name) { name = in_name; };
	// is current species named like given name ?
	inline bool isNamed(std::string in_name) { return (name == in_name); };
	inline void set_p2c_ratio( double in_p2c ) { p2c = in_p2c ; m *= p2c; q *= p2c; };
};

#endif /* SPECIES_H_ */
