/**
 * TLC.h
 *
 *  Created on: Aug 5, 2011
 *      Author: janez
 */

#ifndef TLC_H_
#define TLC_H_

void usage(int argc, char* argv[]);

#define MAX(a,b)	((a)>(b) ? (a) : (b))
#define MIN(a,b)	((a)<(b) ? (a) : (b))
#define IS_ZERO(a)	(fabs(a) < 1e-15)
#define PI		3.1415926535897932
#define EPS0	8.8541e-12

/* define basic values */
#define M_EL	9.11e-31
#define Q_EL	1.60217653e-19

// definitions for particle positions and velocities in initial load and source
#define POSITION_DISTRIBUTION_NONE		0
#define POSITION_DISTRIBUTION_UNIFORM	1
#define POSITION_DISTRIBUTION_RANDOM	2
#define POSITION_DISTRIBUTION_UNIFORM_NO_BORDERS	3
#define POSITION_DISTRIBUTION_UNIFORM_NO_BORDER_LEFT	4
#define POSITION_DISTRIBUTION_UNIFORM_NO_BORDER_RIGHT	5
#define POSITION_DISTRIBUTION_COUNT		6

#define VELOCITY_DISTRIBUTION_NONE			0
#define VELOCITY_DISTRIBUTION_MAXWELLIAN	1
#define VELOCITY_DISTRIBUTION_RANDOM		2
#define VELOCITY_DISTRIBUTION_RANDOM_COLD	3
#define VELOCITY_DISTRIBUTION_COUNT			4

#endif /* TLC_H_ */
